apiVersion: v1
kind: Service
metadata:
  name: web-app
spec:
  ports:
  - port: 80  # веб приложение будет доступно 80 порту по внешнему ip
    protocol: TCP
    targetPort: 3000 # запросы будут идти на 3000 порты контейнеров
  selector:
    app: web-app
  type: LoadBalancer # используем внешний балансировщик

---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: web-app
spec:
  replicas: 5 # считаем что наше приложение критичное по доступности, и не можем себе позволить 5-10 сек ухудшения сервиса на инициализацию нового пода, в замен упавшего
  selector:
    matchLabels:
      app: web-app
  template:
    metadata:
      labels:
        app: web-app
    spec:
      containers:
      - name: web-app
        image: sample.io/web-app:1.2
        readinessProbe:
          httpGet:
            path: /health
            port: 3000
          initialDelaySeconds: 10
          periodSeconds: 10
        ports:
        - containerPort: 3000
        resources:
          requests:
            memory: "128Mi"
            cpu: "100m"

---
apiVersion: autoscaling/v1
kind: HorizontalPodAutoscaler
metadata:
  name: web-app
spec:
  scaleTargetRef:
    apiVersion: apps/v1
    kind: Deployment
    name: web-app
  minReplicas: 2 # считаем приложение критичным, и держим в N+1 реплик, а ночью и когда нагрузка меньше экономим ресурсы
  maxReplicas: 5
  targetCPUUtilizationPercentage: 50 # что бы при падении одной ноды оставшиеся не были загружены более 100%
                                     # конечно расточительно по мощностям, но максимально отказоустойчиво и доступно
